<?php
/*
Plugin Name: WP-HOTWords
Plugin URI: http://www.bernabauer.com/wp-plugins
Description: Inclui o codigo para monetizacao do sistema <a href="http://www.HOTWords.com.br">HOTWords</a>. <a href="options-general.php?page=wp-hotwords.php">Configure</a> o plugin assim que ativa-lo.
Author: Bernardo Bauer
Version: 4.0.2
Author URI: http://www.bernabauer.com/
*/
global $wpdb;
register_activation_hook("/wp-content/plugins/wp-hotwords/wp-hotwords.php", 'hw4wp_activate');
register_deactivation_hook("/wp-content/plugins/wp-hotwords/wp-hotwords.php", 'hw4wp_deactivate');

add_action('admin_notices', 'hw4wp_alerta');
add_action('admin_head', 'hw4wp_admin_head');
add_action('admin_menu', 'hw4wp_add_pages');
add_action('wp_head', 'hw4wp_footer_css');
add_action('wp_footer', 'hw4wp_footer');

add_action('hw4wp_cron', 'wphw_relatorio' );

add_action('dbx_post_sidebar', 'hw4wp_write_post_sidebar');

add_action('edit_post', 'HW_code_exclusionUpdate');
add_action('publish_post', 'HW_code_exclusionUpdate');
add_action('save_post', 'HW_code_exclusionUpdate');

add_action('edit_post', 'HW_custom_colorUpdate');
add_action('publish_post', 'HW_custom_colorUpdate');
add_action('save_post', 'HW_custom_colorUpdate');

$hw4wp_options = get_option('hw4wp_options');

	if ($hw4wp_options['show_post'] == 'checked') 
		add_filter('the_content', 'hw4wp_core', 9);

	if ($hw4wp_options['show_com'] == 'checked') 
		add_filter('comment_text','hw4wp_core', 9);


#load_plugin_textdomain("hw4wp", 'wp-content/plugins/wp-hotwords');

/***************************************************************************************************
 *  Coisas para serem feitas na instalacao do plugin
 */
function hw4wp_activate() {

	require_once(ABSPATH . 'wp-admin/upgrade-functions.php');

	global $wpdb;

	$hw4wp_options = array('id'=>'', 'colour'=>'', 'username'=>'','password'=>'', 'footer_align'=>'center', 'footer_line'=>'inline', 'show_com'=>'', 'show_post'=>'checked', 'show_index'=>'', 'clicks'=>'', 'earnings'=>'', 'lastrun'=>'', 'version'=>'4.0.1');

	add_option('hw4wp_options', $hw4wp_options);

	if (!wp_next_scheduled('hw4wp_cron')) {
		wp_schedule_event( time(), 'daily', 'hw4wp_cron' );
	}

	delete_option('HW_align_footer');
	delete_option('HW_artigo');
	delete_option('HW_comentario');
	delete_option('HW_debug');
	delete_option('HW_line_footer');
	delete_option('HW_link_colour');
	delete_option('HW_multiPost');
	delete_option('HWid');

}

/***************************************************************************************************
 *  Antes de desativar a funcao abaixo eh executada
 */
 function hw4wp_deactivate() {

	require_once(ABSPATH . 'wp-admin/upgrade-functions.php');

	global $wpdb;
	
	delete_option('hw4wp_options');

	if (wp_next_scheduled('hw4wp_cron')) {
		wp_clear_scheduled_hook('hw4wp_cron' );
	}
}

/***************************************************************************************************
 *  Alerta sobre problemas com a configuracao do plugin
 */
function hw4wp_alerta() {

	if (  !isset($_POST['info_update']) ) {
	
	$hw4wp_options = get_option('hw4wp_options');
	
		if ($hw4wp_options == '') {
			$msg = '* Parece que você atualizou a versão nova sem desativar o plugin!! Por favor desative e re-ative.';
		} else {
	
			if ( $hw4wp_options['id'] == '') {
				$msg = '* '.__('Você ainda não informou seu código de afiliados HOTWords!!!',$domain).'<br />'.sprintf(__('Se você já tem uma conta informe <a href="%1$s">aqui</a>, caso contrário <a href="%2$s">crie uma agora</a>.',$domain), "options-general.php?page=wp-hotwords.php","http://site.hotwords.com.br/parceiro6.jsp").'<br />'; 
			}
		}
		
		if ($msg) {
			echo "<div class='updated fade-ff0000'><p><strong>".__('WP-HOTWords Alerta!', $domain)."</strong><br /> ".$msg."</p></div>";
		}
		return;
	}
}

/***************************************************************************************************
 *  Inclui um menu de administracao
 */
function hw4wp_add_pages() {
    if ( function_exists('add_options_page') ) {
        add_options_page('WP-HOTWords', 'WP-HOTWords', 9, 'wp-hotwords.php', 'hw4wp_options_page');
    }
}

/***************************************************************************************************
 *  Codigos a serem inseridos no HEAD do admin.
 */
function hw4wp_admin_head() {

	echo '	<link rel="stylesheet" href="'.get_settings('home').'/wp-content/plugins/wp-hotwords/js_color_picker_v2.css" media="screen">';
	echo '	<script src="'.get_settings('home').'/wp-content/plugins/wp-hotwords/color_functions.js"></script>		';
	echo '	<script type="text/javascript" src="'.get_settings('home').'/wp-content/plugins/wp-hotwords/js_color_picker_v2.js"></script>';
}

/***************************************************************************************************
 *  Inclui o codigo do HOTWords 
 */
function hw4wp_core( $content ) {

	global $thePostID;
	global $wp_query;

	$hw4wp_options = get_option('hw4wp_options');

	$thePostID = $wp_query->post->ID;
	$EmbedHWTag = get_post_custom_values('wp-hotwords');
	
    if (!is_single() AND ($hw4wp_options['show_index'] != 'checked'))
		return ($content);

	if ( (!is_feed()) AND (!$EmbedHWTag[0])) 
	{
		$content = '<!-- wp-hotwords begin --><div id=HOTWordsTxt name=HOTWordsTxt>'.$content.'</div><!-- wp-hotwords end -->';
	}

	return ($content);
}

/***************************************************************************************************
 *  Mostra rodape de creditos da monetizacao e desenvolvedor do plugin
 */
function hw4wp_footer() {

	$hw4wp_options = get_option('hw4wp_options');
	
	global $wp_query;
	global $thePostID;
	
	switch ($hw4wp_options['footer_line']) {
	case "br_before":
		$br_before = "<br />";
		break;
	case "br_after":
		$br_after = "<br />";
		break;
	case "p":
		$p_before = "<p>";
		$p_after = "</p>";
		break;
	case "inline":
		break;
	}

	$corpadrao = $hw4wp_options['colour'];
	
	$corpersonalizada = get_post_meta($thePostID, 'wp-hotwords_custom_color',true);	
	
	if (is_single())
	{
		if ($corpersonalizada != '')
		{
			$HWcor = $corpersonalizada;
		}
		else
		{
			$HWcor = $corpadrao;
		}
	}
	else
	{
		$HWcor = $corpadrao;
	}
	
	$HWcor = str_replace('#','',$corpadrao);
	if ($HWcor != "")
		$HWcolour = "&amp;cor=".$HWcor;
	else
		$HWcolour = '';

	echo "<script type='text/javascript' src='http://www.hotwords.com.br/show.jsp?id=".$hw4wp_options['id'].$HWcolour."'></script>";
	echo $br_before.$p_before.'<div class="hw4wp_footer">Este blog é monetizado pelo <a href="http://www.HOTWords.com.br" rel="nofollow">HOTWords</a> utilizando o plugin <a href="http://www.bernabauer.com/wp-hotwords" rel="nofollow">WP-HOTWords ';
	echo $hw4wp_options['version'].'</a>.</div>'.$p_after.$br_after;
}
/***************************************************************************************************
 *  Inclui o CSS para o footer
 */
function hw4wp_footer_css() {

$hw4wp_options = get_option('hw4wp_options');
	$HW_align_footer = $hw4wp_options['footer_align'];
	
	echo '<style type="text/css"> <!-- div.hw4wp_footer {';
	
	if ($HW_align_footer == 'center')
		echo "text-align: center;";
	
	if ($HW_align_footer == 'left')
		echo "text-align: left;";
	
	if ($HW_align_footer == 'right')
		echo "text-align: right;";
	echo " } --> </style>";
}

/***************************************************************************************************
 *  Barra Lateral para edicao opcoes WP-HOTWords por artigo.
 */
function hw4wp_write_post_sidebar() {

	global $post;

	$checked='';	
	$showHW = get_post_meta($post->ID, 'wp-hotwords', true);
	$ccHW = get_post_meta($post->ID, 'wp-hotwords_custom_color', true);
	
	if ($showHW == "nao")
		$checked = "checked";

	echo "<div id=\"slugdiv\" class=\"postbox if-js-closed\"><h3>WP-HOTWords</h3><div class=\"inside\">";
	echo '<input type="checkbox" name="HWcodeExclusion" value="nao"'.$checked.'> Sem anúncios<br />';
	echo '<input type="hidden" name="HWcodeExclusion-key" id="HWcodeExclusion-key" value="' . wp_create_nonce('HWcodeExclusion') . '" />';

	echo '<br />Cor diferenciada:<br />';
	echo '<input type="hidden" name="HW_custom_color-key" id="HW_custom_color-key" value="' . wp_create_nonce('rgb2') . '" />';
	echo '<input type="text" size="7" maxlength="7" name="rgb2" value="'.$ccHW.'">';
	echo '<input type="button" value="Escolher" onclick="showColorPicker(this,document.forms[0].rgb2)">';

	echo '<br />Para usar a cor padrão, deixe a caixa de texto acima em branco.';


	echo "  </div></div>";

}

/***************************************************************************************************
 *  Painel de opcoes do plugin
 */
function hw4wp_options_page() {

	//pega dados da base
	$hw4wp_options = get_option('hw4wp_options');

	//processa novos dados para atualizacao
    if ( isset($_POST['info_update']) ) {

		$hw4wp_options['id'] = $_POST['id'];

        if (isset($_POST['footer_align'])) 
            $hw4wp_options['footer_align'] = $_POST['footer_align'];
            
        if (isset($_POST['footer_line'])) 
            $hw4wp_options['footer_line'] = $_POST['footer_line'];

         if (isset($_POST['rgb2'])) 
            $hw4wp_options['colour'] = $_POST['rgb2'];

		$hw4wp_options['show_post'] = $_POST['show_post'];
		$hw4wp_options['show_com'] = $_POST['show_com'];
		$hw4wp_options['show_index'] = $_POST['show_index'];

		$hw4wp_options['username'] = $_POST['username'];
		$hw4wp_options['password'] = $_POST['password'];

		//atualiza base de dados com informacaoes do formulario		
		update_option('hw4wp_options',$hw4wp_options);
		
    }


	switch ($hw4wp_options['footer_align']) {
	case "center":
		$center = "checked";
		break;
	case "left":
		$left = "checked";
		break;
	case "right":
		$right = "checked";
		break;
	}

	switch ($hw4wp_options['footer_line']) {
	case "br_before":
		$br_before = "checked";
		break;
	case "br_after":
		$br_after = "checked";
		break;
	case "p":
		$p = "checked";
		break;
	case "inline":
		$inline = "checked";
		break;
	}

	$cor = $hw4wp_options['colour'];
	if ($hw4wp_options['colour'] == '') {
		$cor = '';
		$msg = 'Cor padrão do HOTWords.';
	}


    ?>
    <div class="wrap">
    			<form method="post">

    <h2>Configuração WP-HOTWords</h2>
    
    <table class="form-table">
	 <tr>
		<th scope="row" valign="top">Código de Afiliado</th>
		<td>
			 Código : <input name="id" type="text" id="id" value="<?php echo $hw4wp_options['id']; ?>" size=8  />
			<label for="id"><br />O seu código de afiliado pode ser encontrado na página "Configurar HOTWords". A última caixa informa o "scriptHOTWords". Seu código de afiliado é o número após o texto 'show.jsp?id='.</label>
		</td>
	 </tr>
	</table>
	<br />

    <table class="form-table">
	 <tr>
		<th scope="row" valign="top">Defina onde os anúncios deverão ser mostrados</th>
		<td>
			<input type="checkbox" name="show_post" value="checked" <?php echo $hw4wp_options['show_post']; ?>> No texto do artigo <br />
			<input type="checkbox" name="show_com" value="checked" <?php echo $hw4wp_options['show_com']; ?>> No texto dos comentários (*)<br />
			<input type="checkbox" name="show_index" value="checked" <?php echo $hw4wp_options['show_index']; ?>> Na página com mais de um artigo (*)<br />
			<label><br /><strong>(*) Atenção :</strong> Se você quer seu blog validado no padrão <a href="http://en.wikipedia.org/wiki/XHTML">XHTML</a> você não deve habilitar a opção para mostrar anúncios nos comentários e em páginas com mais de um artigo. Páginas com mais de um artigo detectadas pelo WP-HOTWords são: Página principal, página de categoria, arquivo, resultado de pesquisa ou página de arquivo por minuto, hora, dia, mês ou ano.<br />
			Para validar seu blog, utilize o <a href="http://validator.w3.org/">XHTML Validator</a>.</label>
		</td>
	 </tr>
	</table>
	<br />

    <table class="form-table">
	 <tr>
		<th scope="row" valign="top">Personalização do link HOTwords</th>
		<td>
			<table>
				<tr>
					<td><strong>Cor atual: </strong></td><td WIDTH="20" BGCOLOR="<?php echo $cor;?>"></td><td><?php echo $msg; ?></td><td><strong>Nova cor : </strong><input type="text" id="cor" size="10" maxlength="7" name="rgb2" value="<?php echo $cor;?>">
					<input type="button" value="Escolha uma Cor" onclick="showColorPicker(this,document.forms[0].rgb2)">
					</td>
				</tr>
			</table>
			<label><br />Você pode selecionar a cor padrão para os links de anúncios HOTWords aqui. Se você quiser, pode ainda trocar a cor dos links em um determinado artigo. Para fazê-lo, basta selecionar a cor na página de edição do artigo.<br /><br />Para usar cor padrão do HOTWords deixe a caixa abaixo vazia.</label>
		</td>
	 </tr>
	</table>
	<br />

    <table class="form-table">
	 <tr>
		<th scope="row" valign="top">Aparência do Rodapé</th>
		<td>
			Você pode configurar como o rodapé irá aparecer no seu blog.<br />
			<br />
			Alinhamento horizontal: 
			<input type="radio" name="footer_align" value="center" <?php echo $center;?> /> Centralizado
			<input type="radio" name="footer_align" value="left" <?php echo $left;?>/> Esquerda
			<input type="radio" name="footer_align" value="right" <?php echo $right;?>/> Direita
			<br />
			Alinhamento vertical:
			<input type="radio" name="footer_line" value="br_before" <?php echo $br_before;?>/> Nova linha antes do rodapé
			<input type="radio" name="footer_line" value="br_after" <?php echo $br_after;?>/> Nova linha após o rodapé
			<input type="radio" name="footer_line" value="p" <?php echo $p;?>/> Novo parágrafo
			<input type="radio" name="footer_line" value="inline" <?php echo $inline;?>/> Mesma linha
		
		</td>
	 </tr>
	</table>
	<br />

    <table class="form-table">
	 <tr>
		<th scope="row" valign="top">Relatórios por email<br />(experimental)</th>
			<td>
			Informe o seu login no HOTWords: <input name="username" type="text" id="username" value="<?php echo $hw4wp_options['username']; ?>" size=50  />
			<br /> 
			Informe a sua senha no HOTWords: <input name="password" type="password" id="password" value="<?php echo $hw4wp_options['password']; ?>" size=10  />		
			<label><br />Se você quiser ser avisado de seus ganhos diariamente por email, preencha os campos de login e senha.<br /><br />		<?php
		
			if ( $hw4wp_options['username'] != '' AND $hw4wp_options['password'] != '') {

				//GET Difference between Server TZ and desired TZ
				$sec_diff = date('Z') - (get_option('gmt_offset') * 3600);
				$sec_diff = (($sec_diff <= 0) ? '+' : '-') . abs($sec_diff);			
									
				echo "<br />próximo envio de relatorio ". date('d/m/Y H:i:s', wp_next_scheduled('hw4wp_cron') + $sec_diff); 
			}
		?></label>
			</td>
	 </tr>
	</table>
	<br />

		<span class="submit">
			<input type="submit" name="info_update" value="Atualizar Opções &raquo;" />
		</span>
		
    <h2>Sobre</h2>
		<p>O sistema <a href="http://www.HOTWords.com.br">HOTWords</a> publica anúncios contextuais dentro de textos de uma grande e qualificada rede de sites parceiros, o que possibilita ao anunciante comunicar-se com seu público-alvo de maneira inovadora, direta e segmentada.</p>
		<p>Este plugin foi desenvolvido por <a href="http://bernabauer.com/">Bernardo Bauer</a> para facilitar a vida do blogueiro que utiliza <a href="http://wordpress.org/">Wordpress</a>. Com ele os artigos recebem automaticamente os Divs necessários para que o programa funcione no seu blog e também inclui o script no rodapé. Com este plugin você não precisa mais editar o seu tema para que o HOTWords funcione.</p>
		<p>Ultra-pequeno FAQ:</p>
		<ul>
		<li><strong>Não aparecem anúncios nos meus artigos. Verifiquei o código da página do artigo e os códigos do HOTwords não estão sendo incluídos. O que eu faço?</strong><br />
		O problema pode estar no tema do seu blog, garanta que existe a chamada "wp_footer()" no arquivo de tema "Rodapé" (ou footer, caso seu wordpress esteja em inglês) do seu tema ativo.</li>
		<li><strong>Preciso me cadastrar em algum lugar para usar este plugin?</strong><br />
		Sim! é necessário ter uma conta ativa no sistema HOTWords para que o plugin funcione como esperado.</li>
		<li><strong>Posso determinar que não sejam mostrados anúncios do HOTwords em alguns artigos?</strong><br />
		Se você quiser que algum artigo não receba anúncios do HOTwords, basta escolher a opção "Não mostrar anúncios do HOTWords neste artigo" na página de edição de artigos.</li>
		<li><strong>Como faço para ter mais de um site cadastrado no HOTWords?</strong><br />
		Você deve cadastrar seu novo site na página de cadastro de parceiros HOTWords com o mesmo e-mail que você já utiliza em sua conta atual. Você poderá acessar os relatórios de todos seus sites com o mesmo login e senha porém os pagamentos não serão somados, cada site será pago individualmente.<br />
		Informação extraída do FAQ do HOTWords disponível <a href="http://site.hotwords.com.br/relatorios/info/duvidas_4.jsp">aqui</a>.</li>
		<li><strong>Como posso otimizar meus ganhos com o HOTWords?</strong><br />
		O primeiro passo é ter conteúdo relevante. O segundo é personalizar as cores de links do HOTWords para serem mais atraentes para o seu tema. Veja mais <a href="http://site.hotwords.com.br/relatorios/info/duvidas_6.jsp">aqui</a>.</li>
	
		</ul>
		<p>O autor deste plugin não recebe nada pelo desenvolvimento e sua manutenção. Se você quiser demonstrar seu reconhecimento pelo trabalho realizado, faça uma doação:</p>
		<center>
		<!-- INICIO FORMULARIO BOTAO PAGSEGURO -->
		<form target="pagseguro" action="https://pagseguro.uol.com.br/security/webpagamentos/webdoacao.aspx" method="post">
		<input type="hidden" name="email_cobranca" value="bernabauer@bernabauer.com"/>
		<input type="hidden" name="moeda" value="BRL"/>
		<input type="image" src="https://pagseguro.uol.com.br/Security/Imagens/FacaSuaDoacao.gif" name="submit" alt="Pague com PagSeguro - é rápido, grátis e seguro!"/>
		</form>
		<!-- FINAL FORMULARIO BOTAO PAGSEGURO -->
		</center>
		<p>Acesse reguralmente a <a href="http://www.bernabauer.com/wp-hotwords/">página do plugin</a> para verificar se novas versões foram liberadas e instruções de como atualizar seu plugin.</p>
    </form>
    </div>
<?php
}


/*
 *  Atualiza a opcao de personalizacao do codigo HOTWords para artigo/pagina
 */
 
function HW_code_exclusionUpdate($id)
{

  // authorization
	if ( !current_user_can('edit_post', $id) )
		return $id;
	// atualiza a exclusao de anuncios por artigo
	if ( !wp_verify_nonce($_POST['HWcodeExclusion-key'], 'HWcodeExclusion') )
		return $id;

	// atualiza a exclusao de anuncios por artigo
	$setting = $_POST['HWcodeExclusion'];

	// apaga o metadado se for conteudo vazio
	if (!$setting)
		delete_post_meta($id, 'wp-hotwords');
	else
		$meta_exists = update_post_meta($id, 'wp-hotwords', $setting);
	if((!$meta_exists) AND ($setting != ''))
	{
		add_post_meta($id, 'wp-hotwords', $setting);	
	}
	return $id;
}

/*
 *  Atualiza a opcao de cor diferenciada do codigo HOTWords de artigo/pagina
 */

function HW_custom_colorUpdate($id)
{

  // authorization
	if ( !current_user_can('edit_post', $id) )
		return $id;
	// atualizacao da cor personalizada de artigos para artigos
	if ( !wp_verify_nonce($_POST['HW_custom_color-key'], 'rgb2') )
		return $id;

	// apaga o metadado se for conteudo vazio
	$setting = $_POST['rgb2'];
	if (!$setting)
		delete_post_meta($id, 'wp-hotwords_custom_color');
	else
		$meta_exists = update_post_meta($id, 'wp-hotwords_custom_color', $setting);
	if((!$meta_exists) AND ($setting != ''))
	{
		add_post_meta($id, 'wp-hotwords_custom_color', $setting);	
	}
	return $id;
}

function decode_header ( $str )
{
    $part = preg_split ( "/\r?\n/", $str, -1, PREG_SPLIT_NO_EMPTY );
    $out = array ();
    for ( $h = 0; $h < sizeof ( $part ); $h++ )
    {
        if ( $h != 0 )
        {
            $pos = strpos ( $part[$h], ':' );
            $k = strtolower ( str_replace ( ' ', '', substr ( $part[$h], 0, $pos ) ) );
            $v = trim ( substr ( $part[$h], ( $pos + 1 ) ) );
        }
        else
        {
            $k = 'status';
            $v = explode ( ' ', $part[$h] );
            $v = $v[1];
        }

        if ( $k == 'set-cookie' )
        {
                $out['cookies'][] = $v;
        }
        else if ( $k == 'content-type' )
        {
            if ( ( $cs = strpos ( $v, ';' ) ) !== false )
            {
                $out[$k] = substr ( $v, 0, $cs );
            }
            else
            {
                $out[$k] = $v;
            }
        }
        else
        {
            $out[$k] = $v;
        }
    }
    return $out;
}

/***********************************************************************/
/* This function has been copyed from Akismet 
// Returns array with headers in $response[0] and body in $response[1]
*/
function wphw_http_post($request, $host, $path, $port = 80) {
	global $wp_version;

	$hw4wp_options = get_option('hw4wp_options');

	$http_request  = "POST $path HTTP/1.0\r\n";
	$http_request .= "Host: $host\r\n";
	$http_request .= "Content-Type: application/x-www-form-urlencoded; charset=" . get_option('blog_charset') . "\r\n";
	$http_request .= "Content-Length: " . strlen($request) . "\r\n";
	$http_request .= "User-Agent: WordPress/$wp_version | wp-hotwords/".$hw4wp_options['version']."\r\n";
	$http_request .= "\r\n";
	$http_request .= $request;

	$response = '';
	if( false != ( $fs = @fsockopen($host, $port, $errno, $errstr, 10) ) ) {
		fwrite($fs, $http_request);

		while ( !feof($fs) )
			$response .= fgets($fs, 1160); // One TCP-IP packet
		fclose($fs);
		$response = explode("\r\n\r\n", $response, 2);
	}
	return $response;
}



/***********************************************************************
 * Send data to wphw HQ 
 */
function wphw_relatorio() {
	
	$hw4wp_options = get_option('hw4wp_options');

	if ( $hw4wp_options['username'] != '' AND $hw4wp_options['password'] != '') {

		if ( $hw4wp_options['lastrun'] != date("m.d.y")) {
		
		$hw4wp_options['lastrun'] = date("m.d.y");
		
		//send data
		$response = wphw_http_post("login=".$hw4wp_options['username']."&senha=".$hw4wp_options['password'], 'central.hotwords.com.br', '/login.jsp');
	
		$info =  decode_header($response[0]);
		$cookie1 = "Cookie: ".$info[cookies][0]."\r\n";
		$cookie1 .= "Cookie: ".$info[cookies][1]."\r\n";
		$cookie1 .= "Cookie: ".$info[cookies][2]."\r\n";
	
		$http_request  = "GET /relatorios/redir.jsp HTTP/1.1\r\n";
		$http_request .= "Host: central.hotwords.com.br\r\n";
		$http_request .= "Content-Type: application/x-www-form-urlencoded; charset=" . get_option('blog_charset') . "\r\n";
		$http_request .= "Content-Length: " . strlen($request) . "\r\n";
		$http_request .= "User-Agent: WordPress/$wp_version | wp-hotwords/".$hw4wp_options['version']."\r\n";
		$http_request .= "Cookie: ".$info[cookies][0]."\r\n";
		$http_request .= "Cookie: ".$info[cookies][1]."\r\n";
		$http_request .= "Cookie: ".$info[cookies][2]."\r\n";
		$http_request .= "\r\n";
		$http_request .= $request;
	
		$response = '';
		if( false != ( $fs = @fsockopen('central.hotwords.com.br', 80, $errno, $errstr, 10) ) ) {
			fwrite($fs, $http_request);
	
			while ( !feof($fs) )
				$response .= fgets($fs, 1160); // One TCP-IP packet
			fclose($fs);
			$response = explode("\r\n\r\n", $response, 2);
		}
	
		$info =  decode_header($response[0]);
	
		$http_request  = "GET /relatorios/seleciona_site.jsp?id=".$hw4wp_options['id']." HTTP/1.1\r\n";
		$http_request .= "Host: central.hotwords.com.br\r\n";
		$http_request .= "Content-Type: application/x-www-form-urlencoded; charset=" . get_option('blog_charset') . "\r\n";
		$http_request .= "Content-Length: " . strlen($request) . "\r\n";
		$http_request .= "User-Agent: WordPress/$wp_version | wp-hotwords/".$hw4wp_options['version']."\r\n";
		$http_request .= "Cookie: ".$info[cookies][0]."\r\n";
		$http_request .= $cookie1;
		$http_request .= "\r\n";
		$http_request .= $request;
	
		$response = '';
		if( false != ( $fs = @fsockopen('central.hotwords.com.br', 80, $errno, $errstr, 10) ) ) {
			fwrite($fs, $http_request);
	
			while ( !feof($fs) )
				$response .= fgets($fs, 1160); // One TCP-IP packet
			fclose($fs);
			$response = explode("\r\n\r\n", $response, 2);
		}
	
		$info =  decode_header($response[0]);
	
		$http_request  = "GET /relatorios/detalhado.jsp HTTP/1.1\r\n";
		$http_request .= "Host: central.hotwords.com.br\r\n";
		$http_request .= "Content-Type: application/x-www-form-urlencoded; charset=" . get_option('blog_charset') . "\r\n";
		$http_request .= "Content-Length: " . strlen($request) . "\r\n";
		$http_request .= "User-Agent: WordPress/$wp_version | wp-hotwords/".$hw4wp_options['version']."\r\n";
		$http_request .= "Cookie: ".$info[cookies][0]."\r\n";
		$http_request .= "Cookie: ".$info[cookies][1]."\r\n";
		$http_request .= "Cookie: ".$info[cookies][2]."\r\n";
		$http_request .= "\r\n";
		$http_request .= $request;
	
		$response = '';
		if( false != ( $fs = @fsockopen('central.hotwords.com.br', 80, $errno, $errstr, 10) ) ) {
			fwrite($fs, $http_request);
	
			while ( !feof($fs) )
				$response .= fgets($fs, 1160); // One TCP-IP packet
			fclose($fs);
			$response = explode("\r\n\r\n", $response, 2);
		}
	
	//parse response
		$pattern = '/((R\$ )?[0-9]*,?[0-9]{2}|0)/i';
		preg_match_all($pattern, substr($response[1], strpos($response[1], "*Total"), 600), $matches, PREG_PATTERN_ORDER);
		
		$dif_cliques = (int) $matches[0][2] - (int) $hw4wp_options['clicks'];
		$dif_ganhos = (float) str_replace(",", ".", substr($matches[0][7],3)) - (float) $hw4wp_options['earnings'];
	
		$hw4wp_options['clicks'] = $matches[0][2];
		$hw4wp_options['earnings'] = str_replace(",", ".", substr($matches[0][7],3));
	
		update_option('hw4wp_options',$hw4wp_options);
	
		$message = "Você está recebendo o relatório de ganhos que o plugin WP-HOTWords gera diariamente. Os dados deste relatório são extraídos da página de administração do sistema HOTWords. Se você tiver sugestões, por favor, entre em contato com o autor através do formulário de contato http://www.bernabauer.com/contato. \n\n";
		$message.= "Ganhos acumulados: R$ ".str_replace(",", ".", substr($matches[0][7],3))."*\n";
		$message.= "Diferença em relação à ontem: R$ ".$dif_ganhos."*\n";
		$message.= "Cliques acumulados: ".$matches[0][2]."\n";
		$message.= "Diferença em relação à ontem: ".$dif_cliques."\n";
		$message.= "\n\n* Valores podem sofrer alteração no fechamento do mês.\n";
		$message.= "\n----\n";
		$message.= "Mensagem gerada automaticamente pelo plugin WP-HOTWords - http://www.bernabauer.com/wp-hotwords\n";
		
		wp_mail(get_option('admin_email'), "Relatório WP-HOTWords para ".get_option('blogname'), $message);
	
	
	
		//if all gets lost, pray for the gods!
		if ( !is_array($response) || !isset($response[1]) || $response[1] != 'ok' && $response[1] != 'nok' ) {
			return 'failed';
		}
		//urray! this stuff really works!
		return $response[1];
		}
	}
}
?>